'From Squeak2.8 of 13 June 2000 [latest update: #2348] on 20 July 2000 at 7:25:56 am'!
Smalltalk renameClassNamed: #NetworkResolverTestOT as: #NetworkResolverTestUnix!
NetworkResolverTest subclass: #NetworkResolverTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!

!NetworkResolverTestUnix commentStamp: '<historical>' prior: 0!
SUnit Class to test Squeak Resolver
By: John M McIntosh 
johnmci@smalltalkconsulting.com
www.smalltalkconsulting.com
2000/05/03

v1.0 2000/5/13 seems to work ok for  Open Transport

Note constants about web sites, echo ip etc etc WILL need to change for your site!
NetworkSocketOpenTest subclass: #NetworkSocketOpenTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!

!NetworkSocketOpenTestUnix commentStamp: '<historical>' prior: 0!
SUnit Class to test Squeak socket code
By: John M McIntosh 
johnmci@smalltalkconsulting.com
www.smalltalkconsulting.com
2000/05/03
v1.0 2000/5/13 seems to work ok for OT (Open Transport)

Note constants about web sites, echo ip etc etc WILL need to change for your site
This test suite moves megabytes of data and will take a long time to run.
!
NetworkSocketOpenTestUnix subclass: #NetworkSocketAcceptTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!
NetworkSocketOpenTestUnix subclass: #NetworkSocketBasicTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!
NetworkSocketOpenTestUnix subclass: #NetworkSocketConnectTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!
NetworkSocketOpenTestUnix subclass: #NetworkSocketListenTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!
NetworkSocketOpenTestUnix subclass: #NetworkSocketSevereErrorTestUnix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network Tests'!

!NetworkResolverTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 15:13'!
badResolverErrorBadAddress
	"This is the macintosh specific OT error code, other platforms will have 
	different numbers
	-23045 is MacTCP value
	-3150 is Mac Open Transport value"

	^ 4

! !

!NetworkResolverTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 15:10'!
badResolverErrorNoData
	"This is the macintosh specific OT error code, other platforms will have 
	different numbers
	-3162 is Mac Open Transport value"

	^ 1

! !

!NetworkResolverTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 15:10'!
badResolverErrorNoSuchName
	"This is the macintosh specific OT error code, other platforms will have 
	different numbers
	-23045 is MacTCP value
	-3170 is Mac Open Transport value"

	^ 1

! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'rww 7/18/2000 15:48'!
testAbortLookup
	self lookupDisney.
	address _ self takesAShortAmountOfTime: [NetNameResolver addressForName: 'www.disney.jp' timeout: 0].
	self should: [address isNil].	
	self checkStatusAddressIsBad! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'rww 7/18/2000 15:48'!
testAddressForName
	self lookupDisney.
	address _ self badAddressForName: 'www.disney' timeout: self timeOutValue.
	self checkStatusAddressIsBad.
	self lookupDisney.
	address _ self badAddressForName: 'www.disney.' timeout: self timeOutValue.
	self checkStatusAddressIsBad.
	self lookupDisney.
	address _ self badAddressForName: 'www.' timeout: self timeOutValue.
	self checkStatusAddressIsBad.
	self lookupDisney.
	address _ self goodAddressForName: (NetNameResolver stringFromAddress: disneyAddress)  timeout: self timeOutValue.
	self should: [disneyAddress = address].	
	self checkStatusOk.
	self lookupDisney.
	address _ self badAddressForName: '' timeout: self timeOutValue.
	self should: [address isNil].	
	self should: [NetNameResolver resolverError = self badResolverErrorBadAddress].
	self should: [NetNameResolver resolverStatus = 3]. "Resolver Error"

! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:09'!
testAddressFromString
	super testAddressFromString! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:03'!
testErrorAndStatus
	super testErrorAndStatus
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:03'!
testHaveNetwork
	super testHaveNetwork
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:04'!
testLocalAddressString
	super testLocalAddressString
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:04'!
testLocalHostNameAndAddress
	super testLocalHostNameAndAddress
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:04'!
testNameForAddress
	super testNameForAddress
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:04'!
testResolverSemaphore
	super testResolverSemaphore
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:05'!
testStringFromAddress
	super testStringFromAddress
! !

!NetworkResolverTestUnix methodsFor: 'testing' stamp: 'JMM 6/3/2000 19:05'!
testpromptUserForHostAddress
	super testpromptUserForHostAddress
! !


!NetworkSocketOpenTest methodsFor: 'testing' stamp: 'rww 7/20/2000 02:49'!
testSocketOpenListenXferDataToEchoPort
	"Echo data to a echo server" 
	| sock1 localAddress desiredPort rand stringSizes strings counter buffer index getData dataBytesSent dataBytesRead timesToRun maximumBufferSize incr validationCopy |
	
	desiredPort _ 7.
	timesToRun _ 1000.
	Socket initializeNetwork.

	rand _ Random new.
	stringSizes _ OrderedCollection new.
	25 timesRepeat: [| cand | 
		cand _ (rand next) * 8192 + 1.
		stringSizes add: cand asInteger].
	25 timesRepeat: [| cand | 
		cand _ (rand next) * 65536 + 1.
		stringSizes add: cand asInteger].
	strings _ OrderedCollection new: stringSizes size.
	counter _ 1.
	stringSizes do: [:i |
		buffer _ WriteStream on: (String new: 128000).
		1 to: i do: [:j | (rand next > 0.5) ifTrue: [buffer nextPut: $x] ifFalse: [buffer nextPut: $y]].
		strings add: buffer contents.
		counter _ counter + 1].
	validationCopy _ strings deepCopy.
	maximumBufferSize _ 65536 + 1.
	getData _ String new: maximumBufferSize.

	localAddress _ NetNameResolver localHostAddress.
	sock1 _ Socket new.
	sock1 connectTo: self echoHostAddress port: desiredPort.
	sock1 waitForConnectionUntil: Socket standardDeadline.
	
	self checkConnectedSocket: sock1 toAddress: self echoHostAddress toPort: desiredPort
		fromAddress: sock1 localAddress fromPort: sock1 localPort.

	timesToRun timesRepeat: 
		[index _ (rand next * strings size) asInteger + 1.
			[" Just for fun fork this sender off, why wait"
			dataBytesSent _ sock1 sendData: (strings at: index).
			self should: [dataBytesSent = (strings at: index) size]] fork.
		dataBytesRead _ 0.
		[dataBytesRead < (strings at: index) size] whileTrue: 
			[incr _ sock1 readInto: getData startingAt: (dataBytesRead + 1).
			dataBytesRead _ dataBytesRead + incr].
			self should: [dataBytesRead = (strings at: index) size].
			self should: [(getData copyFrom: 1 to: dataBytesRead) = (strings at: index)]].

	self checkConnectedSocket: sock1 toAddress:  self echoHostAddress toPort: desiredPort
		fromAddress: localAddress fromPort: sock1 localPort.
	self should: [strings = validationCopy].
	[sock1 closeAndDestroy] fork.

! !

!NetworkSocketOpenTest methodsFor: 'testing' stamp: 'rww 7/20/2000 02:52'!
testSocketOpenListenXferDataToEchoPortUDP
	"Echo data to a echo server we use a small buffer size to ensure we don't loss UDP data
	For non-local hosts we still could and this test will fail" 

	| sock1 localAddress desiredPort rand stringSizes strings buffer index getData dataBytesSent dataBytesRead timesToRun incr maximumUDPBufferSize validationCopy |
	
	desiredPort _ 7.
	timesToRun _ 10000.
	maximumUDPBufferSize _ 1024.
	Socket initializeNetwork.

	rand _ Random new.
	stringSizes _ OrderedCollection new: maximumUDPBufferSize/2.
	getData _ String new: maximumUDPBufferSize.
	maximumUDPBufferSize/2 asInteger timesRepeat:
		[stringSizes add: ((rand next) * (maximumUDPBufferSize - 1) ) rounded + 1].
	strings _ OrderedCollection new: stringSizes size.
	stringSizes do: [:i |
		buffer _ WriteStream on: (String new: maximumUDPBufferSize).
		1 to: i do: [:j | (rand next > 0.5) ifTrue: [buffer nextPut: $x] ifFalse: [buffer nextPut: $y]].
		strings add: buffer contents].
	validationCopy _ strings deepCopy.
	localAddress _ NetNameResolver localHostAddress.
	sock1 _ Socket newUDP.
	sock1 setPeer: self echoHostAddress port: desiredPort.
	sock1 waitForConnectionUntil: Socket standardDeadline.
	
	self checkConnectedSocket: sock1 toAddress: self echoHostAddress toPort: desiredPort
		fromAddress: sock1 localAddress fromPort: sock1 localPort.

	timesToRun timesRepeat: 
		[index _ (rand next * (strings size - 1)) rounded + 1.
			[" Just for fun fork this sender off, why wait"
			dataBytesSent _ sock1 sendData: (strings at: index).
			self should: [dataBytesSent = (strings at: index) size]] fork.
		dataBytesRead _ 0.
		[dataBytesRead < (strings at: index) size] whileTrue: 
			[incr _ sock1 readInto: getData startingAt: (dataBytesRead + 1).
			dataBytesRead _ dataBytesRead + incr].
			self should: [dataBytesRead = (strings at: index) size].
			self should: [(getData copyFrom: 1 to: dataBytesRead) = (strings at: index)]].

	self checkConnectedSocket: sock1 toAddress:  self echoHostAddress toPort: desiredPort
		fromAddress: localAddress fromPort: sock1 localPort.
	self should: [strings = validationCopy].
	[sock1 closeAndDestroy] fork.

! !


!NetworkSocketOpenTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 15:04'!
badResolverErrorNoSuchName
	"This is the macintosh specific OT error code, other platforms will have 
	different numbers
	-23045 is MacTCP value
	-3170 is Mac Open Transport value"

	^ 1

! !

!NetworkSocketOpenTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 15:20'!
badSocketNoConnection
	"This is the macintosh specific OT error code, other platforms will have 
	different numbers
	-23008 is MacTCP value
	-3256 is Mac Open Transport value"

	^ 0
! !

!NetworkSocketOpenTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 15:39'!
badSocketNotInOrder
	"This is the macintosh specific OT error code, other platforms will have 
	different numbers
	-23008 is MacTCP value
	-3155 is Mac Open Transport value"

	^ 0
! !

!NetworkSocketOpenTestUnix methodsFor: 'constants' stamp: 'rww 7/18/2000 19:36'!
mailHostName
	^'katie.vnet.net'! !

!NetworkSocketOpenTestUnix methodsFor: 'constants' stamp: 'rww 7/20/2000 04:51'!
timeServerHostName
	^'squeak.cs.uiuc.edu'
! !


!NetworkSocketAcceptTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 02:00'!
testSocketListenAccept
	super testSocketListenAccept! !

!NetworkSocketAcceptTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 07:25'!
testSocketListenAcceptWithDelay
	| sock1 sock2 desiredPort localAddress sock3 sock4 sock5 |

	Socket initializeNetwork.
	localAddress _ NetNameResolver localHostAddress.
	desiredPort _ 54322.
	sock1 _ Socket new.
	sock2 _ Socket new.
	sock1 listenOn: desiredPort backlogSize: 4.
	sock2 connectTo: localAddress port: desiredPort.
	sock1 waitForConnectionUntil: Socket standardDeadline.
	sock2 waitForConnectionUntil: Socket standardDeadline.
	sock3 _ sock1 accept.
	self checkConnectedSocket: sock2 toAddress: localAddress toPort: desiredPort 
		fromAddress: localAddress fromPort: sock2 localPort.
	self checkConnectedSocket: sock3 toAddress: localAddress toPort: sock2 localPort 
		fromAddress: localAddress fromPort: sock3 localPort.
	[sock1 closeAndDestroy] fork.
	[sock2 closeAndDestroy] fork.
	[sock3 closeAndDestroy] fork.

(Delay forMilliseconds: 1) wait.

	desiredPort _ 54323.
	sock3 _ Socket new.
	sock4 _ Socket new.
	sock3 listenOn: desiredPort backlogSize: 4.
	sock4 connectTo: localAddress port: desiredPort.
	sock3 waitForConnectionUntil: Socket standardDeadline.
	sock4 waitForConnectionUntil: Socket standardDeadline.
	sock5 _ Socket acceptFrom: sock3.
	self checkConnectedSocket: sock4 toAddress: localAddress toPort: desiredPort 
		fromAddress: localAddress fromPort: sock4 localPort.
	self checkConnectedSocket: sock5 toAddress: localAddress toPort: sock4 localPort 
		fromAddress: localAddress fromPort: sock5 localPort.
	[sock3 closeAndDestroy] fork.
	[sock4 closeAndDestroy] fork.
	[sock5 closeAndDestroy] fork.! !


!NetworkSocketBasicTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 01:51'!
testCheckNetworkConnected
	super testCheckNetworkConnected! !

!NetworkSocketBasicTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 01:51'!
testCheckNetworkInitialized
	super testCheckNetworkInitialized! !

!NetworkSocketBasicTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 01:53'!
testCheckSocketUtilities
	super testCheckSocketUtilities! !

!NetworkSocketBasicTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 01:51'!
testLoopBack
	^super testLoopBack! !

!NetworkSocketBasicTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 01:52'!
testNilPeerName
	super testNilPeerName! !

!NetworkSocketBasicTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 01:59'!
testSocketOpenClose
	super testSocketOpenClose! !


!NetworkSocketConnectTestUnix methodsFor: 'testing' stamp: 'rww 7/20/2000 01:59'!
testCheckHttpPortLogic
	super testCheckHttpPortLogic! !

!NetworkSocketConnectTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 01:59'!
testSocketGetData
	| serverAddr sock firstString firstStringSize secondString |
	Socket initializeNetwork.
	serverAddr _ NetNameResolver addressForName: self mailHostName timeout: self timeOutValue.
	self checkStatusOk.

	sock _ Socket new.
	self checkUnconnectedSocket: sock.
	sock connectTo: serverAddr port: 25.
	self checkConnectedSocket: sock toAddress: serverAddr toPort: 25 fromAddress: sock localAddress fromPort: sock localPort.
	firstString _ String new: 0.
	firstStringSize _ sock readInto: firstString startingAt: 1.
	self should: [firstString = '' and: [firstString size = 0]].
	self should: [firstStringSize = 0].
	firstString _ String new: 1.
	firstStringSize _ sock readInto: firstString startingAt: 1.
	self should: [firstString = '2' and: [firstString size = 1]].
	self should: [firstStringSize = 1].
	self should: [sock dataAvailable].
	secondString _ sock getData.
	self should: [firstString,secondString = self expectedSMTPString].
	sock closeAndDestroy.
	self shouldnt: [sock isValid].
	self should: [sock statusString = 'destroyed'].
! !

!NetworkSocketConnectTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 01:59'!
testSocketGetDataFailure
	| serverAddr sock |
	Socket initializeNetwork.
	serverAddr _ NetNameResolver addressForName: self httpHostName timeout: self timeOutValue.
	self checkStatusOk.

	sock _ Socket new.
	self checkUnconnectedSocket: sock.
	sock connectTo: serverAddr port: 80.
	self checkConnectedSocket: sock toAddress: serverAddr toPort: 80 fromAddress: sock localAddress fromPort: sock localPort.
	self takesALongAmountOfTime: [sock waitForDataUntil: (Socket deadlineSecs: self timeOutValue)].
	self shouldnt: [sock dataAvailable].
	sock closeAndDestroy.
	self shouldnt: [sock isValid].
	self should: [sock statusString = 'destroyed'].
! !

!NetworkSocketConnectTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 01:59'!
testSocketGetDataWaitCheck
	| serverAddr sock |
	Socket initializeNetwork.
	serverAddr _ NetNameResolver addressForName: self mailHostName timeout: self timeOutValue.
	self checkStatusOk.

	sock _ Socket new.
	self checkUnconnectedSocket: sock.
	sock connectTo: serverAddr port: 25.
	self checkConnectedSocket: sock toAddress: serverAddr toPort: 25 fromAddress: sock localAddress fromPort: sock localPort.
	self takesAShortAmountOfTime: [sock waitForDataUntil: (Socket deadlineSecs: self timeOutValue)].
	self should: [sock dataAvailable].
	sock closeAndDestroy.
	self shouldnt: [sock isValid].
	self should: [sock statusString = 'destroyed'].
! !

!NetworkSocketConnectTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 01:59'!
testSocketOutOfOrderErrors
	super testSocketOutOfOrderErrors! !

!NetworkSocketConnectTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 02:00'!
testSocketdiscardReceivedData
	super testSocketdiscardReceivedData! !

!NetworkSocketConnectTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 02:12'!
testUDPGetTime
	| tcpPort serverAddr sock localAddress dateAndTime ourListenPort |

	tcpPort _ 13. 
	Socket initializeNetwork.
	localAddress _ NetNameResolver localHostAddress.
	serverAddr _ NetNameResolver addressForName: self timeServerHostName timeout: 10.

	sock _ Socket newUDP.
	self should: [sock semaphore excessSignals = 0].
	sock setPeer: serverAddr port: tcpPort.
	self should: [sock semaphore excessSignals = 0].
	self checkUDPSocketOK: sock.
	self checkConnectedSocket: sock toAddress: serverAddr toPort: tcpPort fromAddress: sock localAddress fromPort: sock localPort.
	sock sendData: '!!'.
	self takesAShortAmountOfTime: [sock waitForDataUntil: (Socket deadlineSecs: self timeOutValue)].
	self should: [sock dataAvailable].
	self should: [sock semaphore excessSignals = 0].
	dateAndTime _ sock getResponseNoLF.
	self should: [sock semaphore excessSignals = 0].
	self should: [dateAndTime size > 12].
	self shouldnt: [sock dataAvailable].
	sock closeAndDestroy.

	ourListenPort _ 54321.
	sock _ Socket newUDP.
	self should: [sock semaphore excessSignals = 0].
	sock setPort: ourListenPort.
	self should: [sock semaphore excessSignals = 0].
	self checkUDPSocketOK: sock.
	self checkUDPSocket: sock fromAddress: localAddress fromPort: ourListenPort.
	sock sendData: '!!' toHost: serverAddr port: 13.
	self takesAShortAmountOfTime: [sock waitForDataUntil: (Socket deadlineSecs: self timeOutValue)].
	self should: [sock dataAvailable].
	self checkConnectedSocket: sock toAddress: serverAddr toPort: tcpPort fromAddress: localAddress fromPort: sock localPort.
	self should: [sock semaphore excessSignals = 0].
	dateAndTime _ sock getResponseNoLF.
	self should: [sock semaphore excessSignals = 0].
	self should: [dateAndTime size > 12].
	self shouldnt: [sock dataAvailable].
	sock closeAndDestroy.


	sock _ Socket newUDP.
	self should: [sock semaphore excessSignals = 0].
	self checkUDPSocketOK: sock.
	self checkUDPSocketWildCard: sock fromAddress: localAddress fromPort: (Socket wildcardPort).
	sock sendData: '!!' toHost: serverAddr port: 13.
	self takesAShortAmountOfTime: [sock waitForDataUntil: (Socket deadlineSecs: self timeOutValue)].
	self should: [sock dataAvailable].
	self checkConnectedSocket: sock toAddress: serverAddr toPort: tcpPort fromAddress: localAddress fromPort: sock localPort.
	self should: [sock semaphore excessSignals = 0].
	dateAndTime _ sock getResponseNoLF.
	self should: [sock semaphore excessSignals = 0].
	self should: [dateAndTime size > 12].
	self shouldnt: [sock dataAvailable].
	sock closeAndDestroy.

	ourListenPort _ (Socket wildcardPort).
	sock _ Socket newUDP.
	self should: [sock semaphore excessSignals = 0].
	sock setPort: ourListenPort.
	self should: [sock semaphore excessSignals = 0].
	self checkUDPSocketOK: sock.
	self checkUDPSocket: sock fromAddress: localAddress fromPort: sock localPort.
	sock sendData: '!!' toHost: serverAddr port: 13.
	self takesAShortAmountOfTime: [sock waitForDataUntil: (Socket deadlineSecs: self timeOutValue)].
	self should: [sock dataAvailable].
	self checkConnectedSocket: sock toAddress: serverAddr toPort: tcpPort fromAddress: localAddress fromPort: sock localPort.
	self should: [sock semaphore excessSignals = 0].
	dateAndTime _ sock getResponseNoLF.
	self should: [sock semaphore excessSignals = 0].
	self should: [dateAndTime size > 12].
	self shouldnt: [sock dataAvailable].
	sock closeAndDestroy.! !


!NetworkSocketListenTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 02:12'!
testSocketOpenListenXferDataToEchoPort
	super testSocketOpenListenXferDataToEchoPort! !

!NetworkSocketListenTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 02:12'!
testSocketOpenListenXferDataToEchoPortUDP
	super testSocketOpenListenXferDataToEchoPortUDP! !

!NetworkSocketListenTestUnix methodsFor: 'as yet unclassified' stamp: 'rww 7/20/2000 02:44'!
testSocketSendSomeData
	super testSocketSendSomeData! !

!NetworkSocketListenTestUnix methodsFor: 'nil' stamp: 'rww 7/20/2000 02:44'!
testSocketOpenListen
	super testSocketOpenListen! !


!NetworkSocketSevereErrorTestUnix methodsFor: 'nil' stamp: 'rww 7/20/2000 02:40'!
testSocketOpenListenXferData
	super testSocketOpenListenXferData! !


!NetworkSocketBasicTestUnix reorganize!
('testing' testCheckNetworkConnected testCheckNetworkInitialized testCheckSocketUtilities testLoopBack testNilPeerName)
('as yet unclassified' testSocketOpenClose)
!

